<template>
	<el-container class="mainBox mainBoxHeaderNoBorder">
		<el-main class="nopadding">
			<div class="searchMain">
				<div class="searchItem">
					<label class="name">时间</label>
					<el-date-picker class="input" type="daterange" :size="size" v-model="params.keyword" :popper-options="{ placement: 'bottom-start' }" value-format="yyyy-MM-dd" start-placeholder="开始日期" end-placeholder="结束日期" clearable></el-date-picker>
				</div>
				<div class="searchItem">
					<label class="name">工单号</label>
					<el-input class="input" :size="size" v-model="params.keyword" placeholder="工单号" clearable></el-input>
				</div>
				<div class="searchItem">
					<label class="name">维保供应商</label>
					<el-select class="input" :size="size" v-model="params.keyword" placeholder="维保供应商" clearable>
						<el-option v-for="item in setMap.status" :key="item" :label="item.name" :value="item.value"></el-option>
					</el-select>
				</div>
				<div class="searchItem">
					<label class="name">状态</label>
					<el-select class="input" :size="size" v-model="params.keyword" placeholder="状态" clearable>
						<el-option v-for="item in setMap.status" :key="item" :label="item.name" :value="item.value"></el-option>
					</el-select>
				</div>
				<div class="searchItem searchBtn">
					<el-button :size="size" type="primary" icon="el-icon-search" @click="upSearch">查询</el-button>
					<el-button :size="size" type="info" icon="el-icon-RefreshRight">重置</el-button>
				</div>
			</div>
			<scTable ref="table" :apiObj="list.apiObj" row-key="id" @selection-change="selectionChange" stripe :size="size">
				<el-table-column label="工单号" prop="order_sn" width="150"></el-table-column>
				<el-table-column label="别名" prop="alias" width="200"></el-table-column>
				<el-table-column label="排序" prop="sort" width="80"></el-table-column>
				<el-table-column label="创建时间" prop="date" width="180"></el-table-column>
				<el-table-column label="状态" prop="status" width="80">
					<template #default="scope">
						<el-switch v-model="scope.row.status" :size="size" @change="changeSwitch($event, scope.row)" :loading="scope.row.$switch_status" :active-value="true" :inactive-value="false"></el-switch>
					</template>
				</el-table-column>
				<el-table-column label="备注" prop="remark" min-width="150"></el-table-column>
				<el-table-column label="操作" fixed="right" align="center" width="150">
					<template #default="scope">
						<el-dropdown>
							<el-button class="noBorderBtn" icon="el-icon-more" :size="size"></el-button>
							<template #dropdown>
								<el-dropdown-menu>
									<el-dropdown-item @click="table_show(scope.row, 'see')" icon="sc-icon-See">查看详情</el-dropdown-item>
									<el-dropdown-item @click="table_edit(scope.row, 'edit')" icon="sc-icon-Edit">编辑</el-dropdown-item>
									<el-dropdown-item @click="table_del(scope.row, 'delete')" icon="sc-icon-Delete">删除</el-dropdown-item>
								</el-dropdown-menu>
							</template>
						</el-dropdown>
					</template>
				</el-table-column>
			</scTable>
		</el-main>
	</el-container>
</template>

<script>
export default {
	name: 'warehouse',
	components: {

	},
	data() {
		return {
			size:'small',
			setMap:{
				status:[]
			},

			dialog: {
				save: false,
				permission: false
			},
			list:{
				apiObj: {},
				column:[]
			},
			selection: [],
			params: {
				keyword: null
			}
		}
	},
	methods: {
		//添加
		add(){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open()
			})
		},
		//编辑
		table_edit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('edit').setData(row)
			})
		},
		//查看
		table_show(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('show').setData(row)
			})
		},
		//权限设置
		permission(){
			this.dialog.permission = true
			this.$nextTick(() => {
				this.$refs.permissionDialog.open()
			})
		},
		//删除
		async table_del(row){
			const reqData = {id: row.id};
			const res = await this.$API.demo.post.post(reqData);
			if(res.code == 200){
				this.$refs.table.refresh()
				this.$message.success("删除成功")
			}
		},
		//批量删除
		async batch_del(){
			this.$confirm(`确定删除选中的 ${this.selection.length} 项吗？`, '提示', {
				type: 'warning'
			}).then(() => {
				const loading = this.$loading();
				this.$refs.table.refresh()
				loading.close();
				this.$message.success("操作成功")
			}).catch(() => {

			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		//表格内开关
		changeSwitch(val, row){
			row.status = row.status == '1'?'0':'1'
			row.$switch_status = true;
			setTimeout(()=>{
				delete row.$switch_status;
				row.status = val;
				this.$message.success("操作成功")
			}, 500)
		},
		//搜索
		upSearch(){

		},

		//本地更新数据
		handleSaveSuccess(data, mode){
			if(mode=='add'){
				this.$refs.table.refresh()
			}else if(mode=='edit'){
				this.$refs.table.refresh()
			}
		}
	}
}
</script>

<style lang="scss" scoped>

</style>
